cordova.define("com.baitian.cordova.http.HttpClient", function(require, exports, module) {
    var argscheck = require('cordova/argscheck'),
        exec = require('cordova/exec'),
        option = require('./HttpOption');

    function setExpireOption(op, expired) {
        if (expired > 0) {
            op["HttpCachePolicy"] = option.HttpCachePolicy.WebPriority;
            op["HttpExpiredSecond"] = expired;
        }
    };

    var httpClient = {};
    httpClient.get = function(url, expired, success, error) {
        var op = {
            "HttpRequestType": option.HttpRequestType.Get
        };
        setExpireOption(op, expired);
        exec(success, error, 'HttpClient', 'request', [url, {},
            op
        ])
    }
    httpClient.getJSON = function(url, expired, success, error) {
        var op = {
            "HttpRequestType": option.HttpRequestType.Get
        };
        setExpireOption(op, expired);
        exec(function(data){
            success(eval('(' + data + ')'));
        }, function(data){
            error(data);
        }, 'HttpClient', 'request', [url, {}, op])
    }
    httpClient.post = function(url, args, expired, success, error) {
        var op = {
            "HttpRequestType": option.HttpRequestType.Post
        };
        setExpireOption(op, expired);
        exec(success, error, 'HttpClient', 'request', [url, args,
            op
        ])
    }
    httpClient.image = function(url, success, error) {
        exec(function(data) {
            var pos = url.lastIndexOf(".");
            var temp = url.substring(pos + 1);
            success("data:image/" + temp + ";base64," + data);
        }, error, 'HttpClient', 'request', [url, {}, {
            "HttpRequestType": option.HttpRequestType.Get,
            "HttpResponseDataType": option.HttpResponseDataType.Data,
            "HttpCachePolicy": option.HttpCachePolicy.CachePriority,
            "HttpDuplicatePolicy": option.HttpDuplicatePolicy.PreviousPriority,
            "HttpExpiredSecond": 3600 * 24 * 5
        }])
    };
    module.exports = httpClient;
});