;(function($){
    /* 本地代码代理工具类 */
    var MobileAgent = (function() {
		var userAgent = (navigator.userAgent).toLowerCase(),
			agentArr = userAgent.split("_");

		function _getPlatform() {
			var platform = userAgent.substr(0, 7),
				platform1 = userAgent.substr(0, 3);
			if (platform == "android") {
				return "android";
			}
			if (platform1 == "ios") {
				return "ios";
			}
			return null;
		}

		function _getVersion() {
			if (null == _getPlatform()) return 6;
			return agentArr[2];
		}

		function _getWhere() {
			if (null == _getPlatform()) return "apple";
			return agentArr[4];
		}

		/*
		 *获取平台信息，如果不是移动平台，则直接返回 "pc",否则返回"ios","android" 或 "other"
		 */
		function _getPlatformNormal(){
			var u = (navigator.userAgent).toLowerCase();
			var platformInfo = {         //移动终端浏览器版本信息
		                isTrident: u.indexOf('trident') > -1, //IE内核
		                isPresto: u.indexOf('presto') > -1, //opera内核
		                isWebKit: u.indexOf('applewebkit') > -1, //苹果、谷歌内核
		                isGecko: u.indexOf('gecko') > -1 && u.indexOf('khmtl') == -1, //火狐内核
		                isMobile: !!u.match(/applewebKit.*mobile.*/), //是否为移动终端
		                isIos: !!u.match(/\(i[^;]+;( u;)? cpu.+mac os x/), //ios终端
		                isAndroid: u.indexOf('android') > -1 || u.indexOf('linux') > -1, //android终端或uc浏览器
		                isIphone: u.indexOf('iphone') > -1 , //是否为iPhone或者QQHD浏览器
		                isIpad: u.indexOf('ipad') > -1, //是否iPad
		                isIpod: u.indexOf('ipod') > -1 //是否ipod
		            };
		    var platform;
		 	do{
		 		if(!platformInfo.isMobile){
		 			platform = "pc";
		 			break;
		 		}
		 		if(platformInfo.isIos){
		 			platform = "ios";
		 			break;
		 		}
		 		if(platformInfo.isAndroid){
		 			platform = "android";
		 			break;
		 		}
		 		platform = "other";
		 	}while(0);
		 	return platform;
		}
		function _getUrlValueWithKey(key){
			var reg = new RegExp("(^|&|\\?)"+key+"=([^&]*)(&|$)","i");
			//var reg = new RegExp("(?:\\?|#|&)" + key + "=([^&]*)(?:$|&|#)", "i");
			var str = decodeURIComponent(window.location.search);
			var res = str.match(reg);
			if(res)return res[2];
			return null;
		}
		function _isLogin() {
			var uuid = (result = new RegExp('(?:^|; )' + encodeURIComponent("uuid") + '=([^;]*)').exec(document.cookie)) ? decode(result[1]) : null;
			//alert("uuid:"+uuid);
			if(uuid == null || uuid == undefined){
				return false;
			}
			return true;
		}
		return {
			getPlatform: _getPlatform,	/* 获取平台 return "ios" or "android" or null*/
			getVersion: _getVersion,	/* 获取版本号 return int */
			getPlatformNormal: _getPlatformNormal,	/* 获取平台 return "pc" or "ios" or "android" or "other" */
			getWhere: _getWhere,	 /* 获取渠道名字 */
			isLogin:_isLogin,
			getUrlValueWithKey:_getUrlValueWithKey
		}
	})();

    /* 全局事件监听、发布工具 */
	var BtPublisher = {
		_o: $({}),
		//添加监听者
		listen: function(ev, func) {
			this._o.bind(ev, function() {
				//屏蔽掉jQuery默认的第一个event对象参数
				func.apply(this, [].slice.call(arguments, 1));
			});
		},
		//发布事件#_#数据
		fire: function() {
			var arr = [];
			var innerArr = [];
			for (var i = 0; i < arguments.length; i++) {
				if (i == 0) {
					arr.push(arguments[i]);
				} else {
					innerArr.push(arguments[i]);
				}
			}
			arr.push(innerArr);
			this._o.trigger.apply(this._o, arr);
		},
		//移除监听
		removeListen: function(ev) {
			this._o.unbind(ev);
		}
	};

    /* 局部事件监听、发布组件 */
	var FSMComponent = {
		_obj : $({}),
		//添加监听者
		listen : function(evt,func,context){
			this._obj.bind(evt,function(){
				//console.log(arguments);
				func.apply(context||this, [].slice.call(arguments,1));
			});
		},
		//发布事件
		fire : function(){
			var _arguments = [];
			var _argsArr = [];
			_arguments.push(arguments[0]);
			for(var i = 1; i < arguments.length; i++){
				_argsArr.push(arguments[i]);
			}
			_arguments.push(_argsArr);
			this._obj.trigger.apply(this._obj,_arguments);
		}
	};

    /* 与客户端通讯工具 */
	var BtCommunication = (function() {
		/* 客户端分享字段编码 */
		var _shareCode = {
			kShareDefault: 0,
			kShareWeixin: 1,/* 分享微信 */
			kShareSina: 1 << 1,/* 分享新浪微博 */
			kShareTencent: 1 << 2,/* 分享先腾讯微博 */
			kShareQQ: 1 << 3,/* 分享QQ */
			kShareWeixinFriend: 1 << 4,/* 分享朋友圈 */
			kShareMessage: 1 << 5 /* 分享短信 */,
			kShareQzone:1 << 6 /* 分享qq空间 */
		};
		var _shareOldCode = {
			kShareDefault: -1,
			kShareWeixin: 0,
			kShareSina: 1,
			kShareTencent: 2,
			kShareQQ: 3,
			kShareWeixinFriend: 4,
			kShareMessage: 5,
			kShareQzone: 6
		};
		var ShareFromId = window.DcShareFromId != undefined ? window.DcShareFromId : 2;
		var ShareType = window.DcShareType != undefined ? window.DcShareType : 0;
		var _shareKeyMap = {
			key_1:{
				shareId: ShareFromId + "_0_" + ShareType
			},
			key_2:{
				shareId: ShareFromId + "_1_" + ShareType
			},
			key_4:{
				shareId: ShareFromId + "_2_" + ShareType
			},
			key_8:{
				shareId: ShareFromId + "_3_" + ShareType
			},
			key_16:{
				shareId: ShareFromId + "_4_" + ShareType
			},
			key_32:{
				shareId: ShareFromId + "_5_" + ShareType
			},
			key_64:{
				shareId: ShareFromId + "_6_" + ShareType
			},
		}
		var androidSinaTimer = null, // 安卓新浪微博回调计时器
			androidSinaDelayCbTime = 5000;
		var curPlatform = (MobileAgent.getPlatform() == "android") ? "android" : "ios",
			curVersion = MobileAgent.getVersion(),
			curWhere = MobileAgent.getWhere();
		/*
		@param {ClientWapProtocol object} +cmds:
		 */
		function _goClientWithCmds(cmds){
			_goClientWithURL(cmds.getUserProtocol());
		}
        /*与本地代码通信入口
         *@param {string} +url
         *attention:该函数在新版本将弃用,连续的快速调用该函数，会丢弃前面的命令，只保留最后一个命令.该函数将替换为 _openURL(url) 
         */
		function _goClientWithURL(url) {
		  // window.location.href = encodeURI(url); // old 
		  if(_isDebug()){
		  	alert(url);
	      	console.log(url);
	      }
		  _openURL(url);
		}
		function _openURL(url){
			var userAgent = (navigator.userAgent).toLowerCase(),
			agentArr = userAgent.split("_");
			if(curPlatform == "android"){// android4.0 以下，不能通过iframe跳转
				var sysVersion = agentArr[1];
				var sysArr = sysVersion.split(".");
				if(sysArr[0] < 4){
					window.location.href = encodeURI(url);
				}else{
					_doOpenURL(url);
				}
			}else{
				_doOpenURL(url);
			}
		}
		function _doOpenURL(url){
			//create an iframe to send the request
			var _iframe = document.getElementById("clientIframeBridge");
			if(MobileAgent.getPlatform() == "android"){
				if(_iframe == undefined || _iframe == null){
					_iframe = document.createElement('iframe');
					_iframe.style.display = "none";
					_iframe.id = "clientIframeBridge";
					_iframe.src = encodeURI(url);
					document.body.appendChild(_iframe);
				}else{
					_iframe.src = encodeURI(url);
				}
			}else{
				/* =========== 兼容ios8 ===========*/
				if(_iframe != undefined && _iframe != null){
					_iframe.parentNode.removeChild(_iframe);
				}
				_iframe = document.createElement('iframe');
				_iframe.style.display = "none";
				_iframe.id = "clientIframeBridge";
				_iframe.src = encodeURI(url);
				document.body.appendChild(_iframe);
			}
            return;
		}
		function _openBrowserWithUrl(url){
			var p = new ClientWapProtocol();
			p.addKeyValues({
				cmd:"browserLink",
				url:url
			});
			_goClientWithURL(p.getUserProtocol());
		}
		function _preShare(shareParam, sucCb, failCb) {
			var p = new ClientWapProtocol();
			var eventId = "pre_share_" + shareParam;
			var shareId = shareParam;
			p.addKeyValues({
				cmd: "preshare",
				shareParam: shareId,
				eventId: eventId,
				cb: "BtPublisher.fire"
			});
			BtPublisher.removeListen(eventId);
			BtPublisher.listen(eventId, function(cmd, shareParamCb) {
				if ((shareParamCb & shareId) > 0) {
					//sucCb(cmd,shareId);
					if (typeof sucCb == "function") sucCb(cmd, shareParamCb, shareId);
				} else {
					//failCb(cmd,shareId);
					if (typeof failCb == "function") failCb(cmd, shareParamCb, shareId);
				}
			});
			BtCommunication.goClientWithURL(p.getUserProtocol());
		}
		/*构建返回至本地代码的对象
		 *@param {object} +obj:
		 *       var obj = {
		 *       	shareKey:+(string),
		 *       	content:(string),
		 *       	imgUrl:(string),
		 *       	targetUrl:(string),
		 *       	otherUrl:(string),
		 *       	shareCode:+(int),
		 *       	shareId:+(string),
		 *       	isLink:(bool)
		 *       }
		 *@return {object}:
		 *       var value = {
		 *       	content:(string),
		 *       	imgUrl:(string),
		 *       	targetUrl:(string)
		 *       }
		 */
        function _constructShareContentToNative(obj){
        	var _obj = {};
            var _Url = null;
            if(obj.shareCode == _shareCode.kShareWeixin || obj.shareCode == _shareCode.kShareWeixinFriend){
             	_Url = obj.targetUrl; // 如果是微信或朋友圈的分享，则取targetUrl字段
            }else{
             	_Url = obj.otherUrl;
            }
            var proUrl = '';
	        if(_Url != undefined && _Url != null){
	          	if(_Url.indexOf("?") >= 0){
			      	proUrl = "&";
			      }else{
			      	proUrl = "?";
			      }
	        }else{
	          	proUrl = "?";
	        }
	        proUrl = proUrl + "s="+obj.shareId+"&"+"k="+obj.shareKey;
	        if(curPlatform == "android" && obj.shareCode == _shareCode.kShareTencent){ //如果是android腾讯微博，&需转码成%26，否则&之后的字符串会被过滤掉,ios反而不会
    			proUrl = encodeURIComponent(proUrl);
    		}
	        if(obj.content != undefined){
	        	_obj.content = obj.content;
	        }
	        if(obj.imgUrl != undefined){
	        	if(curPlatform == "ios"){ // 如果是ios平台，低于11的版本，不能带imgUrl字段，否则微信和朋友圈将只会分享该图片,新浪微博不带图片
	        		if(curVersion >= 11 || obj.shareCode == _shareCode.kShareSina){
	        			_obj.imgUrl = obj.imgUrl;
	        		}
	        	}else{
	        		_obj.imgUrl = obj.imgUrl;
	        	}
	        }
	        if(_Url != undefined ){
	        	_obj.content = obj.content || '';
	        	_obj.targetUrl = _Url + proUrl;
	        	if(obj.isLink == true){
	        		_obj.content += _Url + proUrl;
	        	}
	        	// 如果是android平台，版本号低于27的默认不会将targetUrl字段拼接到content字段后面,ios默认都不拼接
    			if(obj.shareCode == _shareCode.kShareSina || obj.shareCode == _shareCode.kShareTencent)
    				_obj.targetUrl = '　';
	        }
	        //console.log(obj);
	        return _obj;
        }
        /*分享至第三方
         *@param {int} +shareParam: 分享到何处
		 *@param {object} +objs:
		 *       var objs = {
		 *       	shareKey:+(string),
		 *       	imgUrl:(string),
		 *       	content:(string),
		 *       	targetUrl:(string),
		 *       	otherUrl:(string),
		 *       	isLink:(bool)
		 *       }
		 *@param {function} -sucCb: 成功回调函数
		 *@param {function} -failCb: 失败回调函数  
		 */
		function _share(shareParam, objs, sucCb, failCb) {
			var p = new ClientWapProtocol();
			var eventId = "share_" + shareParam;
			var shareId = shareParam;
			p.addKeyValue("cmd", "share");
			p.addKeyValue("shareParam", shareParam);
			p.addKeyValue("eventId", eventId);
			p.addKeyValue("cb", "BtPublisher.fire");
			var key = "key_" + shareId;
			if(_shareKeyMap[key] == undefined){
				alert("分享字段值:"+shareParam+" 不存在,请确认");
				return;
			}
			if(objs.shareKey == undefined){
				alert("分享字段shareKey不能为空");
				return;
			}
			objs.shareCode = shareId;
			objs.shareId = _shareKeyMap[key].shareId;
			p.addKeyValues(_constructShareContentToNative(objs));
			// 安卓新浪微博分享无回调bug修复，使用计时器，默认5秒后发起成功的回调
			if (shareParam == _shareCode.kShareSina && curPlatform == "android") {
				androidSinaTimer = setInterval(function() {
					clearInterval(androidSinaTimer);
					androidSinaTimer = null;
					sucCb.call(this, "share", _shareCode.kShareSina);
				}, androidSinaDelayCbTime);
			} else {
				BtPublisher.removeListen(eventId);
				BtPublisher.listen(eventId, function(cmd, shareParamCb, status) {
					if (0 == status) {
						if (typeof sucCb == "function") sucCb(cmd, shareParamCb);
					} else {
						if (typeof failCb == "function") failCb(cmd, shareParamCb);
					}
				});
			}
			BtCommunication.goClientWithURL(p.getUserProtocol());
		}
		/*
		 *@param: {string} +idx : "tencent|weixin|weibo|qq|friend|qzone"
		 *@param: {object} +shareText :
		 *     var shareText = {
			        shareKey:+(string),
			        tencent:(string),
			        weixin:(string),
			        weibo:(string),
			        qq:(string),
			        friend:(string),
			        targetUrl:(string),
			        imgUrl:(string),
			        iconUrl:(string),
			        otherUrl:(string)
				}
		*/
		function _simpleShareTo(idx,shareText,sucCb,failCb){
	      var objs = {};
	      var shareKey = shareText.shareKey;
	      if(shareKey == undefined){
	      	alert("shareKey字段不能为空");
	      	return;
	      }
	      var tip = "";
	      var shareCode = 0;
	      objs.shareKey = shareKey;
	      switch(idx){
		        case "tencent":{
		          //objs.imgUrl = shareText.imgUrl; // 屏蔽腾讯微博分享图，客户端sdk的原因
		          objs.otherUrl = shareText.otherUrl;
		          objs.isLink = true;
		          objs.content = shareText.tencent;
		          shareCode = BtCommunication.shareCode.kShareTencent;
		          tip = "您还没有安装腾讯微博哦，先去安装吧！";
		          break;
		        }
		        case "weixin":{
		         objs.imgUrl = shareText.iconUrl;
		         objs.content = shareText.weixin;
		         objs.targetUrl = shareText.targetUrl;
		         shareCode = BtCommunication.shareCode.kShareWeixin;
		         tip = "您还没有安装微信哦，先去安装吧！";
		         break;
		        }
		        case "weibo":{
		          objs.imgUrl = shareText.imgUrl;
		          objs.otherUrl = shareText.otherUrl;
		          objs.isLink = true;
		          objs.content = shareText.weibo;
		          shareCode = BtCommunication.shareCode.kShareSina;
		          tip = "您还没有安装新浪微博哦，先去安装吧！";
		          break;
		        }
		        case "qq":{
		          objs.imgUrl = shareText.imgUrl;
		          objs.content = shareText.qq;
		          objs.otherUrl = shareText.otherUrl;
		          shareCode = BtCommunication.shareCode.kShareQQ;
		          tip = "您还没有安装QQ哦，先去安装吧！";
		          break;
		        }
		        case "friend":{
		          objs.imgUrl = shareText.iconUrl;
		          objs.content = shareText.friend;
		          objs.targetUrl = shareText.targetUrl;
		          shareCode = BtCommunication.shareCode.kShareWeixinFriend;
		          tip = "您还没有安装微信哦，先去安装吧！";
		          break;
		        }
		        case "qzone":{
		          objs.imgUrl = shareText.iconUrl;
		          objs.content = shareText.qzone;
		          objs.targetUrl = shareText.targetUrl;
		          objs.otherUrl = shareText.otherUrl;
		          shareCode = BtCommunication.shareCode.kShareQzone;
		          tip = "您还没有安装QQ空间哦，先去安装吧！";
		          break;
		        }
		        default:break;
	      }
	      if(_isDebug()){
	      	BtCommunication.share(shareCode,objs,function(){},function(){});
	      }else{
	      	BtCommunication.preShare(shareCode
      		,function(){
      			/*alert("pre suc"); */
      			setTimeout(function(){
      				BtCommunication.share(shareCode,objs,function(cmd, shareParamCb){
      					sucCb && sucCb(cmd, shareParamCb);
      				},function(cmd, shareParamCb){
      					failCb && failCb(cmd, shareParamCb);
      				});
      			},0);
      		}
      		,function(){/*alert("pre fail");*/alert(tip);});
	      }
	    }

	    /* 跳转到下课聊
	    @param {string} +topicId: 下课聊帖子id
	    @param {int} floorNum: 楼层数
	     */
	    function _goOverClass(topicId,floorNum,cb){
	    	var eventId = "browseOverClass";
	    	var p = new ClientWapProtocol();
	    	p.addKeyValue("cmd", "browseOverClass");
			p.addKeyValue("eventId", eventId);
			p.addKeyValue("topicId",topicId);
			if(typeof floorNum == "function"){
				cb = floorNum;
				floorNum = undefined;
			}else{
				if(floorNum != undefined){
					p.addKeyValue("floorNum",floorNum);
				}
			}
			p.addKeyValue("cb", "BtPublisher.fire");
			BtPublisher.removeListen(eventId);
			BtPublisher.listen(eventId, function(cmd) {
				if (typeof cb == "function") cb(cmd);
			});
			BtCommunication.goClientWithURL(p.getUserProtocol());
	    }
	    /* 跳转本地客户端页面
	    @param {int} +index: 图片地址
	    @param {json string} other: 其他参数，json字符串形式 {param1:xxx,param2:xxx}
	    */
	    function _goAppPage(index,other){
	    	var p = new ClientWapProtocol();
	    	p.addKeyValue("cmd","goAppPage");
	    	p.addKeyValue("index",index);
	    	var _other = typeof other == "object" ? JSON.stringify(other):null;
	    	_other ? p.addKeyValue("other",_other):null;
	    	BtCommunication.goClientWithURL(p.getUserProtocol());
	    }
	    /* 设置导航栏信息
	    @param {string} +back: 返回文案
	    @param {string} +title: 标题文案
	    @param {json string} other: 其他参数，json字符串形式 {param1:xxx,param2:xxx}
	    */
	    function _setNaviInfo(back,title,other){
	    	var p = new ClientWapProtocol();
	    	p.addKeyValue("cmd","setNaviInfo");
	    	p.addKeyValue("back",back);
	    	p.addKeyValue("title",title);
	    	var _other = typeof other == "object" ? JSON.stringify(other):null;
	    	_other ? p.addKeyValue("other",_other):null;
	    	BtCommunication.goClientWithURL(p.getUserProtocol());
	    }
	    /* 点击浏览大图
	    @param {string} +src: 图片地址
	    @param {json string} other: 其他参数，json字符串形式
	    */
	    function _browserPic(src,other){
	    	var p = new ClientWapProtocol();
	    	p.addKeyValue("cmd","browserPic");
	    	p.addKeyValue("src",src);
	    	var _other = typeof other == "object" ? JSON.stringify(other):null;
	    	_other ? p.addKeyValue("other",_other):null;
	    	BtCommunication.goClientWithURL(p.getUserProtocol());
	    }

	    /* 保存图片
	    @param {string} +src: 图片地址
	    @param {json string} other: 其他参数，json字符串形式
	    @param {Fun} sucCb: sucCb(cmd)
	    @parem {Fun} failCb:failCb(cmd)
	    native cb:BtPublisher.fire(eventId,cmd,status);
	    */
	    function _savePic(src,other,sucCb,failCb){
	    	var p = new ClientWapProtocol();
	    	var eventId = "savePicEventId";
	    	p.addKeyValue("cmd","savePic");
	    	p.addKeyValue("eventId", eventId);
	    	p.addKeyValue("src",src);
	    	BtPublisher.removeListen(eventId);
	    	if(typeof other == "function"){
	    		failCb = sucCb;
	    		sucCb = other;
	    		other = undefined;
	    	}else{
	    		var _other = typeof other == "object" ? JSON.stringify(other):null;
	    		_other ? p.addKeyValue("other",_other):null;
	    	}
	    	p.addKeyValue("cb", "BtPublisher.fire");
	    	BtPublisher.listen(eventId, function(cmd, status) {
				if (0 == status) {
					if (typeof sucCb == "function") sucCb(cmd);
				} else {
					if (typeof failCb == "function") failCb(cmd);
				}
			});
	    	BtCommunication.goClientWithURL(p.getUserProtocol());
	    }

	    /* 消息字串打印输出
	    @param {string} +src: 图片地址
	    @param {json string} other: 其他参数，json字符串形式
	    */
	    function _alert(str){
	    	// var p = new ClientWapProtocol();
	    	// var eventId = "alertEventId";
	    	// p.addKeyValue("cmd","alert");
	    	// p.addKeyValue("eventId", eventId);
	    	alert("error:"+str);
	    }

		function _wapLogin(sucCb, failCb) {
			var eventId = "loginEvent";
			var p = new ClientWapProtocol();
			p.addKeyValue("cmd", "login");
			p.addKeyValue("eventId", eventId);
			p.addKeyValue("cb", "BtPublisher.fire");
			BtPublisher.removeListen(eventId);
			BtPublisher.listen(eventId, function(cmd, status) {
				if (0 == status) {
					if (typeof sucCb == "function") sucCb(cmd);
				} else {
					if (typeof failCb == "function") failCb(cmd);
				}
			});
			BtCommunication.goClientWithURL(p.getUserProtocol());
		}
		function _wapUpdate(){
			//window.location.href = "intent:11"; //old
			_openURL("intent:11");
		}
		/*
		登录弹窗
		 */
		function _needLogin(tips,sucCb,failCb){
			var _tips = null;
			var _sucCb,_failCb;
			if(typeof tips == "object"){
				_tips = tips;
				_sucCb = sucCb;
				_failCb = failCb;
			}else{
				_tips = {
					title:"登录提示",
					desc:"你还没有登录哦，不能参加该活动",
					sure:"马上登录"
				}
				_sucCb = tips;
				_failCb = _sucCb;
			}
			var cb = {
				sure:function(){
					_wapLogin(_sucCb,_failCb);
				}
			};
			var html = $("#login-update-template").html();
			if(html.length < 0){
				alert("登录、升级界面模板不存在，请先引入！");
				return;
			}
			$.AlertPopBox(html,_tips,cb);
			
		}
		/*
		更新弹窗
		 */
		function _needUpdate(tips){
			var _tips = null;
			if(typeof tips == "object"){
				_tips = tips;
			}else{
				_tips = {
					title:"升级提示",
					desc:"你的问他版本太低了，不能参加该活动",
					sure:"马上升级"
				}
			}
			var cb = {
				sure:function(){
					_wapUpdate();
				}
			};
			var html = $("#login-update-template").html();
			if(html.length < 0){
				alert("登录、升级界面模板不存在，请先引入！");
				return;
			}
			$.AlertPopBox(html,_tips,cb);
			
		}

		function _isDebug(){
			var isDebug = false;
			var key = "isDebug";
			isDebug = (window._isBtWapDebug == true) ? true : false;
			var reg = new RegExp("(^|&|\\?)"+key+"=([^&]*)(&|$)","i");
			var str = decodeURI(window.location.search);
			var res = str.match(reg);
			var _res = null;
			if(res)_res = res[2];
			if(_res == "true"){
				isDebug = true;
			}
			return isDebug;
		}

		(function(){
			BtPublisher.listen("alertEventId", function(str){
				_alert(str);
			});
		})();

		/* 对外接口 */
		return {
			goClientWithURL: _goClientWithURL,
			goClientWithCmds:_goClientWithCmds,
			shareCode: _shareCode,
			shareOldCode: _shareOldCode,
			preShare: _preShare,
			share: _share,
			wapLogin: _wapLogin,
			wapUpdate:_wapUpdate,
			openBrowserWithUrl:_openBrowserWithUrl,
			needLogin:_needLogin,
			needUpdate:_needUpdate,
			simpleShareTo:_simpleShareTo,
			goOverClass:_goOverClass,
			goAppPage:_goAppPage,
			setNaviInfo:_setNaviInfo,
			savePic:_savePic,
			browserPic:_browserPic
		}
	})();

    /* 协议构造对象 */
	var ClientWapProtocol = function(header,cmds) {
		if(typeof header != "string"){
			cmds = header;
			header = undefined;
		}
		this.userProtocol = (header == undefined ? "bt://" : header);
		this.length = 0;
		this.userSplitCode = (this.userProtocol == "bt://") ? "#_#" : "&";
		(cmds != undefined)&&(this.addKeyValues(cmds));
	}

	ClientWapProtocol.prototype = {
		addKeyValue: function(key, value) {
			if (0 == this.length) {
				this.userProtocol = this.userProtocol + key + "=" + value;
			} else {
				this.userProtocol = this.userProtocol + this.userSplitCode + key + "=" + value;
			}
			this.length += 1;
		},
		addKeyValues: function(objs) {
			for (var obj in objs) {
				if (0 == this.length) {
					this.userProtocol = this.userProtocol + obj + "=" + objs[obj];
				} else {
					this.userProtocol = this.userProtocol + this.userSplitCode + obj + "=" + objs[obj];
				}
				this.length += 1;
			}
		},
		addKeyValuesStr: function(str) {
			var nums = str.split(this.userSplitCode).length;
			if (0 == this.length) {
				this.userProtocol = this.userProtocol + str;
			} else {
				this.userProtocol = this.userProtocol + this.userSplitCode + str;
			}
			this.length += nums;
		},
		getUserProtocol: function() {
			return this.userProtocol;
		}
	}

    window.MobileAgent = MobileAgent;
    window.BtPublisher = BtPublisher;
    window.FSMComponent = FSMComponent;
    window.BtCommunication = BtCommunication;
    window.ClientWapProtocol = ClientWapProtocol;
})(window.jQuery||$);

