var page = {
	data : {
		iqCurrentIndex : 0,
		iqCurrentScore : 0,
		iqCurrentPercent : '',
		iqHasAnswer : 0,
		iqHasErrorOnce : false,
		hasLogin : false,
		isCorrect : false,
		isReAnswer : false,
		iqExercises : null,
		isRequesting : false,
		pageStack : [],
		dcEvtIdMapper : {
			0 : {sure : '4801',share : '4805'},//第一关
			1 : {sure : '4802',share : '4806'},//第二关
			2 : {sure : '4803',share : '4807'},//第三关
			3 : {sure : '4804',share : '4808'},//BOSS关
			4 : {sure : '4810',share : '4809'}//结果页
		}
	},
	util : {
		alert : function(str){
			navigator.alert.toast(str,0,function(data) {
			}, function(message) {
			});
		},
		toast : function(str){
			var box = '<div class="showToast" style="position:fixed;left:0;top:0;text-align:center;width:100%;">\
	                        <div style="display:inline-block;text-align:center;padding:0 1rem;font-size:0.8rem;height: 1.5rem;line-height: 1.5rem;text-align:center;z-index:103;background: #ffcc00;color: #fff;border-radius: 4px;">'+ str +'</div>\
	                    </div>';
	        var $box = $(box);
	        $box.appendTo($('body'));
	        $box.css({
	        	'margin-top' : $(window).height() / 2 - $box.outerHeight() / 2
	        });
	        setTimeout(function(){
	            $box.animate({opacity:0},200,function(){
	                $box.remove();
	            });
	        },3000);
	        $(window).scrollTop($(window).scrollTop()+0);
		}
	},
	init : function(){
		pushPageStack({name:'index',elem:$('.main')});
		page.initData();
		page.getCntData();
	},
	initData : function(){
		var now = new Date();
		var nowDay = now.getFullYear() + '' + (now.getMonth()+1) + '' + now.getDate();
		if (nowDay != window.localStorage.getItem('iqCurrentDay')) {
			window.localStorage.setItem('iqCurrentDay',nowDay);
			window.localStorage.removeItem('iqCurrentIndex');
			window.localStorage.removeItem('iqCurrentScore');
			window.localStorage.removeItem('iqCurrentPercent');
			window.localStorage.removeItem('iqHasErrorOnce');
			window.localStorage.removeItem('iqHasAnswer');
		};
		page.data.iqCurrentIndex = window.localStorage.getItem('iqCurrentIndex')? +window.localStorage.getItem('iqCurrentIndex') : 0;
		page.data.iqCurrentScore = window.localStorage.getItem('iqCurrentScore')? +window.localStorage.getItem('iqCurrentScore') : 0;
		page.data.iqCurrentPercent = window.localStorage.getItem('iqCurrentPercent')? window.localStorage.getItem('iqCurrentPercent') : '';
		page.data.iqHasErrorOnce = window.localStorage.getItem('iqHasErrorOnce');
		page.data.iqHasAnswer = window.localStorage.getItem('iqHasAnswer');

		if (page.data.iqHasAnswer == '1') {
			page.data.iqCurrentIndex++;
			window.localStorage.removeItem('iqHasAnswer');
		};

		navigator.dataTransfer.pull(DataTransferOption.DataTransferPullTarget[0], {}, function(data) {
	        page.data.hasLogin = data;
	    }, function(message) {
	        alert(message); // 输出失败消息。
	    });
	},
	getCntData : function(){
		cordovaDebug.getJSON('http://www.7wenta.com/mobile/iqchallenge.json', function(data){
			if (data.result.resultCode.code == 0) {
				page.data.iqExercises = data.result.value.iqExercises;
				page.renderCnt();
			};
		},function(){
			$('.loadingWrp').html('无法开启挑战，请检查自己的网络设置哦！');
			$('.loadingWrp').click(function(){
				window.location.reload();
			});
		});
	},
	checkOnline : function(suc,fail,always){
		var actionUrl = 'http://www.7wenta.com/mobile/serviceTime.json';
		if (!page.data.isRequesting) {
			page.data.isRequesting = true;
			$.when(
				$.post(actionUrl,function(data){
					suc && suc(data);
				})
			).fail(function(){
				fail && fail();
			}).always(function(){
				always && always();
				page.data.isRequesting = false;
			});
		}
	},
	postAnswer : function(suc,fail,always){
		var actionUrl = 'http://www.7wenta.com/mobile/iqcr.json';
		if (!page.data.isRequesting) {
			page.data.isRequesting = true;
			$.when(
				$.post(actionUrl,{type : page.data.iqCurrentIndex+1},function(data){
					suc && suc(data);
				})
			).fail(function(){
				fail && fail();
			}).always(function(){
				always && always();
				page.data.isRequesting = false;
			});
		};
		
	},
	renderCnt : function(data){
		if (page.data.iqCurrentIndex < page.data.iqExercises.length) {
			page.renderMain(page.data.iqCurrentIndex);
		}else{
			page.renderResult();
		};
	},
	renderMain : function(index){
		var data = page.data.iqExercises[index];
		var template = '<div class="main">\
							<div class="iqBox final_no">\
								<div class="qaMain" answer="${answer}" type="${type}">\
									<div class="qaTitle">${title}</div>\
									<div class="qaCnt">\
										<div class="question mw">\
											<div class="qCnt">${question}</div>\
											${img}\
										</div>\
										<div class="answerWrp pr">\
											<div class="aStatus clearfix pa">\
												<div class="xwIcn l"></div>\
												<div class="xwTxt l"></div>\
											</div>\
											<div class="options mw">${options}</div>\
										</div>\
										<div class="analysis mw hide">\
											<div class="tag">解析</div>\
											<div class="cnt">${analysis}</div>\
										</div>\
										<div class="dailyGift mw hide">\
											<div class="tag">今日特权</div>\
											<div class="cnt">小问IQ博士，每天都给你一次重答难题的机会！</div>\
										</div>\
									</div>\
								</div>\
								<div class="qaBtnWrp mw"></div>\
							</div>\
						</div>';
		var str = '';
		var obj = {
			title : data.title,
			question : data.question,
			img : data.imgUrl ? '<div class="qImgWrp clearfix"><div class="qImg l"><img data-real="'+ data.imgUrl +'" src="'+ httpLk +'/resource/common/style/image/loading_m.png" /></div></div>' : '',
			analysis : data.analyse,
			answer : data.answer,
			type : data.type,
			options : page.renderOptions(data.optionAndContents)
		};
		str = wentaUtil.template(template, obj);
		var $elem = $(str);
		$(window).scrollTop(0);
		$('.innerBody').html($elem);
		page.eventBindAfter($elem);
		page.data.isCorrect = false;
		page.data.isReAnswer = false;
		window.localStorage.setItem('iqCurrentIndex',index);
		window.localStorage.removeItem('iqHasAnswer');
		page.renderStatus(0);
		page.renderBtn(1);
		page.renderTitle();

		(function(){
			var $img = $elem.find('.qImg img');
			var imgUrl = $img.data('real');
			$("<img />")
                .bind("load", function(){
                	$img.attr('src',imgUrl);
                })
                .attr("src", imgUrl);
		})();
	},
	renderResult : function(){
		var template = '<div class="main">\
							<div class="iqBox final_yes">\
								<div class="result mw">\
									<div class="rScore pr">\
										<div class="rCnt pa">\
											<div class="txt">本日IQ挑战分：<span class="num">${score}</span></div>\
										</div>\
									</div>\
									<div class="rTxt">\
										<div>共击败了${percent}%的挑战者</div>\
										<div>分享给小伙伴们炫耀一下自己</div>\
									</div>\
								</div>\
								<div class="qaBtnWrp mw"></div>\
							</div>\
						</div>';
		var str = '';
		var obj = {
			score : page.data.iqCurrentScore,
			percent : page.data.iqCurrentPercent != '' ? page.data.iqCurrentPercent : page.getPercent(page.data.iqCurrentScore)
		};
		str = wentaUtil.template(template, obj);
		$(window).scrollTop(0);
		$('.innerBody').html(str);
		page.renderBtn(4);
		page.renderTitle();
		page.data.iqCurrentPercent = obj.percent;
		window.localStorage.setItem('iqCurrentIndex',page.data.iqCurrentIndex);
		window.localStorage.removeItem('iqHasAnswer');
		window.localStorage.setItem('iqCurrentPercent',page.data.iqCurrentPercent);
		CommonModule.widget.initDailyTask({
			txt : '挑战还不过瘾？敢去答题、做任务吗？',
			suc : function(){
				$('.qaBtnWrp').addClass('hasDailyTask');
			}
		});
	},
	renderTitle : function(){
		var now = new Date();
		var nowDay = (now.getMonth()+1) + '月' + now.getDate() + '日';

		var cNumStr = '一二三四五六七八九十';
		var roundName = '第' + cNumStr[page.data.iqCurrentIndex] + '关';

		if (page.data.iqCurrentIndex == page.data.iqExercises.length - 1) {
			roundName = 'BOSS关';
		};

		if (page.data.iqCurrentIndex < page.data.iqExercises.length) {
			navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[2], {
				show : true,
				content : [roundName,nowDay]
			}, function(data) {
		    }, function(message) {
		        alert(message); // 输出失败消息。
		    });
		}else{
			navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[2], {
				show : true,
				content : ['挑战完成']
			}, function(data) {
		    }, function(message) {
		        alert(message); // 输出失败消息。
		    });
		};
	},
	getPercent : function(score){
		return score > 1 ? (Math.floor(score-1) + '.' + Math.floor(Math.random(1) * 10)) : 0;
	},
	renderOptions : function(data){
		var template = '<div class="opt clearfix">\
							<div class="rad l"></div>\
							<div class="cntWrp l clearfix">\
								<div class="cnt l">\
									<span class="index">${index}</span>.<span class="txt">${text}</span>\
								</div>\
								<div class="sts l"></div>\
							</div>\
						</div>';
		var str = '';
		$.each(data,function(k,v){
			var obj = {
				index : v.option,
				text : v.content
			};
			str += wentaUtil.template(template, obj);
		});
		return str;
	},
	renderStatus : function(type){ /*0普通，1错误，2正确*/
		var xwTxt = '';
		if (type == 1) {
			xwTxt = '呜呜呜~选错了';
		}else if (type == 2) {
			xwTxt = '答对啦！真棒';
		};
		$('.aStatus').removeClass('aStatus_0 aStatus_1 aStatus_2').addClass('aStatus_' + type);
		$('.aStatus').find('.xwTxt').text(xwTxt);
	},
	getShareTxt : function(){
		if (page.data.iqCurrentIndex < page.data.iqExercises.length) {
			return page.data.isCorrect ? '挑战难题成功，IQ就是比你高，不服来战！' : '智商捉急啊…说多了都是泪，求大神现身！';
		}else{
			return '今日IQ挑战分'+ page.data.iqCurrentScore +'，共击败了'+ page.data.iqCurrentPercent +'％的挑战者！看来我是智商最高的一个~';
		}
	},
	renderBtn : function(type){ /*设置下方两个按钮*/
		var mapper = {
			1 : {
				tag : '',
				task : '',
				share : '求助好友',
				sure : '确定',
				shareSucCb : function(){
					// popPageStack(); //分享成功不关闭弹窗
				},
				sureCb : function(elem){
					page.showAnswer();
				}
			},
			2 : {
				tag : '',
				task : '',
				share : '分享好友',
				sure : page.data.iqCurrentIndex + 1 < page.data.iqExercises.length ? '下一关':'完成',
				shareSucCb : function(){
					// popPageStack();
				},
				sureCb : function(){
					if (page.data.iqCurrentIndex + 1 < page.data.iqExercises.length) {
						page.renderMain(++page.data.iqCurrentIndex);
					}else{
						window.localStorage.setItem('iqCurrentIndex',++page.data.iqCurrentIndex);
						page.renderResult();
					};
				}
			},
			3 : {
				tag : '<div class="tag"></div>',
				task : '',
				share : '分享重答',
				sure : '查看解析',
				shareSucCb : function(){
					// popPageStack();
					page.renderMain(page.data.iqCurrentIndex);
					page.data.isReAnswer = true;
				},
				shareFailCb : function(){
					popPageStack();
				},
				sureCb : function(){
					$('.dailyGift').hide();
					page.showAnswer();
				}
			},
			4 : {
				tag : '',
				task : '<div class="dailyTaskBoxWrp"></div>',
				share : '晒战绩，邀请好友PK',
				sure : '挑战作业难题',
				shareSucCb : function(){
					// popPageStack();
				},
				sureCb : function(){
					navigator.switcher.switchView(SwitchOption.SwitchTarget[2], {}, function(data) {
		                // alert(data);
		            }, function(message) {
		                alert(message); // 输出失败消息。
		            });
				}
			}
		};
		var template = '<div class="qaBtn qaBtn_share">\
							${tag}\
							<div class="cnt">${share}</div>\
						</div>\
						${task}\
						<div class="qaBtn qaBtn_sure">\
							<div class="cnt">${sure}</div>\
						</div>';
		var str = wentaUtil.template(template,mapper[type]);
		$('.qaBtnWrp').empty().append(str);
		$('.qaBtnWrp').find('.qaBtn_share').click(function(){
			page.initShareBox({
				comment : page.getShareTxt(),
				url : 'http://www.7wenta.com/jst/iq?index='+ ((page.data.iqCurrentIndex > page.data.iqExercises.length - 1) ? page.data.iqExercises.length - 1 : page.data.iqCurrentIndex),
				img : 'http://static.7wenta.com/mobile/wap/iq/style/img_s/share.png',
				defaultImg : 'http://static.7wenta.com/qa/resource/image/android/logo.png',
				suc : function(){
					mapper[type].shareSucCb && mapper[type].shareSucCb();
				},
				fail : function(){
					mapper[type].shareFailCb && mapper[type].shareFailCb();
				}
			});
			navigator.commonAgent.onEvent({
				id : page.data.dcEvtIdMapper[page.data.iqCurrentIndex].share
			}, {}, function(data) {
	            // alert(data);
	        }, function(message) {
	            alert(message); // 输出失败消息。
	        });
		});
		$('.qaBtnWrp').find('.qaBtn_sure').click(function(){
			var that = $(this);
			mapper[type].sureCb && mapper[type].sureCb(that);

			// 非结果页只对‘确定’统计
			if (type == 1 || type == 4) {
				navigator.commonAgent.onEvent({
					id : page.data.dcEvtIdMapper[page.data.iqCurrentIndex].sure
				}, {}, function(data) {
		            // alert(data);
		        }, function(message) {
		            alert(message); // 输出失败消息。
		        });
			};
		});
	},
	showAnswer : function(elem){ /*显示答案，首日重答不显示正确答案，显示特权提示*/
		var answer = $('.qaMain').attr('answer');
		var myAnswer = $('.qaMain').attr('myAnswer');

		if (!myAnswer) {
			page.util.alert('你还没有勾选答案哦~');
			return;
		};
		
		$('.qaMain').find('.options').addClass('lock');
		if (answer == myAnswer) {
			page.postAnswer(function(data){
				window.localStorage.setItem('iqHasAnswer',1);
				page.data.isCorrect = true;
				$('.qaMain').find('.options .opt').each(function(){
					var that = $(this);
					var opt = that.find('.index').text();
					if (opt == answer) {
						that.addClass('yes');
					}
				});
				page.renderStatus(2);
				$('.analysis').show();
				page.renderBtn(2);
				page.data.iqCurrentScore += (page.data.iqCurrentIndex+1) * 10 * (page.data.isReAnswer ? 0.9 : 1);
				window.localStorage.setItem('iqCurrentScore',page.data.iqCurrentScore);
				if (page.data.hasLogin) {
					page.util.toast('回答正确，经验值+' + (page.data.iqCurrentIndex+1));
				};
			},function(){
				page.util.alert('网络异常，请查看网络是否连接');
			});
		}else{
			page.checkOnline(function(data){
				window.localStorage.setItem('iqHasAnswer',1);
				page.data.isCorrect = false;
				$('.qaMain').find('.options .opt').each(function(){
					var that = $(this);
					var opt = that.find('.index').text();
					if (opt == answer) {
						if (page.data.iqHasErrorOnce) {
							that.addClass('yes');
						};
					}else{
						if (that.hasClass('on')) {
							that.addClass('no');
						};
					};
				});
				page.renderStatus(1);
				if (!page.data.iqHasErrorOnce) {
					window.localStorage.setItem('iqHasErrorOnce',1);
					page.data.iqHasErrorOnce = window.localStorage.getItem('iqHasErrorOnce');
					$('.dailyGift').show();
					page.renderBtn(3);
				}else{
					$('.analysis').show();
					page.renderBtn(2);
				};
			},function(){
				page.util.alert('网络异常，请查看网络是否连接');
			});
		};
	},
	initShareBox : function(opts){
		$.wtBox({
			wholeCnt:'<div class="shareBox">\
						<div class="mainWrp">\
							<div class="shareTxt">\
				                <p>分享给好友</p>\
				            </div>\
				            <div class="sp"></div>\
				            <div class="shareWrp">\
				            	<a href="javascript:;" class="sItem sqq" data-sharecode="qq">QQ</a>\
				            	<a href="javascript:;" class="sItem sqz" data-sharecode="qzone">QQ空间</a>\
				                <a href="javascript:;" class="sItem swx" data-sharecode="weixin">微信</a>\
				            </div>\
				            <div class="shareWrp">\
				                <a href="javascript:;" class="sItem spyq" data-sharecode="friend">朋友圈</a>\
				                <a href="javascript:;" class="sItem sxlwb" data-sharecode="weibo">新浪微博</a>\
				                <a href="javascript:;" class="sItemNull"></a>\
				            </div>\
						</div>\
					</div>',
			backClose : true,
			after : function(elem){
				elem.find('.sItem').click(function(){
					var index = $(this).data("sharecode");
					var comment = opts.comment;
			    	var shareContent = {
			            shareKey:"wenta",// 必须
			            weixin:comment,
			            friend:comment,
			            qq:comment,
			            weibo:comment,
			            tencent:comment,
			            qzone:comment,
			            targetUrl:opts.url,
			            imgUrl:opts.img,
			            iconUrl:opts.defaultImg,  // 微信、朋友圈
			            otherUrl:opts.url // 如果存在otherUrl字段，则会把该字段拼接到新浪微博和腾讯微博分享文案内容后面。此外，qq分享必须存在该字段
			        };
					BtCommunication.simpleShareTo(index,shareContent,function(cmd,shareCode){
		                opts.suc && opts.suc();
		                if (MobileAgent.getPlatform() == 'android') {
		                	page.util.alert('分享成功');
		                };
		            },function(cmd,shareCode){
		            });
				});
				$(window).scrollTop($(window).scrollTop()+0);
			}
		});
	},
	eventBindAfter : function($elem){
		$elem.find('.opt').click(function(){
			var that = $(this);
			// 选项在显示答案之后和请求的时候不能点击
			if (window.localStorage.getItem('iqHasAnswer') != '1' && !page.data.isRequesting) {
				$elem.find('.opt').removeClass('on');
				that.addClass('on');
				$elem.find('.qaMain').attr('myAnswer',that.find('.index').text());
			};
		});
		$elem.find('img').click(function(){
			var that = $(this);
			navigator.widget.showImageDetail(that.attr('src'));
			return false;
		});
	}
}

document.addEventListener("deviceready", function(){
	page.init();
}, false);
document.addEventListener("resume", function(){
	CommonModule.widget.initDailyTask({
		txt : '挑战还不过瘾？敢去答题、做任务吗？',
		suc : function(){
			$('.qaBtnWrp').addClass('hasDailyTask');
		}
	});
}, false);

function pageChange(){
	if (page.data.pageStack[0].name == 'index') {
		page.data.pageStack[0].elem.show();
	};
	navigator.dataTransfer.push(DataTransferOption.DataTransferPushTarget[1], {
		isPageEnd : (page.data.pageStack[0].name == 'index')?true:false
	}, function(data) {
        // alert(data);
    }, function(message) {
        alert(message); // 输出失败消息。
    });
}
function pushPageStack(o){
	page.data.pageStack.unshift(o);
	pageChange();
}
function popPageStack(){
	page.data.pageStack[0].elem.remove();
	page.data.pageStack.shift();
	pageChange();
}
function gotoPageStack(name){
	var count = 0;
	for (var i = 0; i < page.data.pageStack.length; i++) {
		if (page.data.pageStack[i].name != name) {
			page.data.pageStack[i].elem.remove();
			count ++;
		}else{
			break;
		}
	};
	page.data.pageStack = page.data.pageStack.slice(count);
	pageChange();
}

/* 
*  客户端左上角返回按钮的js回调
*/ 
function backButtonCallback() {
	popPageStack();
}